<?php
/*************************************************************************************
* Tab for Community Builder User Profiles to display the pictures the user has up-
* loaded in PonyGallery or JOOM::GALLERY
* 
* Author: Armin Hornung                                   http://www.arminhornung.de
* Date: January 2008
* Version: 2.1
* Released under GNU GPL Public License         http://www.gnu.org/copyleft/gpl.html
*************************************************************************************/


/**
Changelog:

January 2008 - 2.1:
Removed ItemID() function from Ponygallery ML 2.41 beacuse it no longer exists on 2.5
=> compatible with PG-ML 2.5

August 2007 - 2.0: 
now compatible with Joomgallery (beta) and Ponygallery (+ML), released as GalleryTab)
uses details view from Ponygallery ML, e.g. Javascript Popup

**/

class getGalleryTab extends cbTabHandler {
	function getGalleryTab() {
		$this->cbTabHandler();
		}
/**
 * Creates and returns the header of the Gallery tab
 * conatining No. of images, and upload-link if configured 
 **/
  function getHeader($own, $total, $Itemid, $gallery){
  	$return = '';
  	
  	if (intval($total) == 0){
  		$return.="<p>The user has uploaded no images to the Gallery.";
	}
	else {
  		$return.= "<p>Total number of images: <strong>". $total ."</strong><br>";
	}
	
	
  	$gallery_link = sefRelToAbs(($gallery =="joom")?"index.php?option=com_joomgallery$Itemid&func=joom_UserPannel"
  					:"index.php?option=com_ponygallery$Itemid&func=userpannel");	
  		
	$return .=($own)?"Upload images from your <a href=\"$gallery_link\">Gallery User Panel</a>!":"";

        $return.= "</p>";
        return $return;
  }
  /**
   * Helper function from Ponygallery, creates the path for categories
   **/
  function ShowCategoryPath ($cat,$db_catg){
	global $database;
	$cat=intval( $cat );
	$parent_id=1000;
	while ( $parent_id ){
		// read name and parent_id
		$query="select * from $db_catg where cid=$cat";
		$database->setQuery( $query );
		$result=$database->query();
		$parent_id=@mysql_result( $result, 0, 'parent' );
		$name=@mysql_result( $result, 0, 'name' );
		// write path
		if ( empty( $path ) ) {
		$path=$name;
		}
		else {
		$path=$name . ' &gt; ' . $path;
		}
		// next looping
		$cat=$parent_id;
    	}
	return $path . " ";
  }
  
  
  /**
   * Helper function, loads the right language
   **/
  function includeLang($gallery_absolute_path, $mosConfig_lang){
    if (file_exists($gallery_absolute_path."/language/".$mosConfig_lang.".php")) 
        include_once($gallery_absolute_path."/language/".$mosConfig_lang.".php");
    else 
        include_once($gallery_absolute_path."/language/english.php");
        
  }
  
  
/**
 * Main function, displays the Gallery-Tab in Community Builder
 **/	
  function getDisplayTab($tab,$user,$ui) {

    global $database,$mosConfig_live_site, $mosConfig_absolute_path, $my, 
    	   $jg_detailpic_open, $jg_paththumbs, $ag_paththumbs, $mosConfig_lang,
    	   $ag_showdetail, $jg_showdetail, $ag_showrating, $jg_showrating, $ag_showcomment, $jg_showcomment;
           
    
    $joom_config_path =$mosConfig_absolute_path . "/administrator/components/com_joomgallery/config.joomgallery.php"; 	
    $pony_config_path =$mosConfig_absolute_path . "/administrator/components/com_ponygallery/config.ponygallery.php"; 
    $ponyml_javascript = $mosConfig_absolute_path . "/administrator/components/com_ponygallery/config.ponygallery.php"; 
    
    // See if Joomgallery is present, if yes use that one instead
    if(file_exists($joom_config_path))
        $gallery_version = "joom";
    else if(file_exists($pony_config_path))
	$gallery_version = "pony";
    else
        return "Error: No config file of supported galleries found. Is the component Ponygallery or Joomgallery installed?";
        
    // check for Ponygallery-ML 2.1:
    $pgml_modules = $mosConfig_absolute_path. "/administrator/components/com_ponygallery/tools/modules.class.php";
    if ($gallery_version =="pony" && file_exists($pgml_modules))
    	$gallery_version = "pony-ml";
 
     // Initalization for different versions, where names / links differ.
     // Language file must be included here too for i18n in Javascript of Joomgallery
    switch ($gallery_version){
    	case "pony-ml":
    		define( '_PONY_PARENT_MODULE', "1" );
    		$gallery_absolute_path = $mosConfig_absolute_path."/components/com_ponygallery";
    		require_once($pony_config_path); // config and language before Javascript needed
    		$this->includeLang($gallery_absolute_path, $mosConfig_lang);
    		require_once($mosConfig_absolute_path."/components/com_ponygallery/sub_javascript.php");
    		require_once($mosConfig_absolute_path."/administrator/components/com_ponygallery/tools/modules.class.php");
    		$tag = "Gallerytab for Community Builder, by Armin Hornung. Using Ponygallery ML 2.1.";
    	case "pony":
    		$gallery_absolute_path = $mosConfig_absolute_path."/components/com_ponygallery";
    		$this->includeLang($gallery_absolute_path, $mosConfig_lang);
		require_once($mosConfig_absolute_path . "/administrator/components/com_ponygallery/class.ponygallery.php" );	
        	require_once($pony_config_path);
    		$thumbnailpath=$mosConfig_live_site . $ag_paththumbs . "/";
    		
    		$showdetail = $ag_showdetail;
    		$showrating = $ag_showrating;
    		$showcomment = $ag_showcomment;
    		$db_name = "#__ponygallery";
    		$db_cmt_name = "#__ponygallery_comments";
    		$db_catg_name = "#__ponygallery_catg";
    		if ($tag=="") $tag = "Gallerytab for Community Builder, by Armin Hornung. Using Ponygallery.";
    		break;
    	case "joom":
    		define( '_JOOM_PARENT_MODULE', "1" ); // Needs to be before including anything from Joomgallery
    		$gallery_absolute_path = $mosConfig_absolute_path."/components/com_joomgallery";
    		$this->includeLang($gallery_absolute_path, $mosConfig_lang); // Needs to be before loading joomgallery javascript
    		require_once($mosConfig_absolute_path . "/administrator/components/com_joomgallery/class.joomgallery.php" );	
        	require_once($joom_config_path);
        	require_once($mosConfig_absolute_path."/components/com_joomgallery/joom_javascript.php");
        	$thumbnailpath=$mosConfig_live_site . $jg_paththumbs . "/";
    		$showdetail = $jg_showdetail;
    		$showrating = $jg_showrating;
    		$showcomment = $jg_showcomment;
    		$db_name = "#__joomgallery";
    		$db_cmt_name = "#__joomgallery_comments";
    		$db_catg_name = "#__joomgallery_catg";
    		$tag = "Gallerytab for Community Builder, by Armin Hornung. Using Joomgallery.";
    		break;

    }
   
    $uid=intval( mosGetParam( $_REQUEST, "uid", 0 ) );
    $params = $this->params;
    
    // ItemId for Ponygallery-Links (JOOM handles this itself)
    if ($gallery_version == "pony" || $gallery_version =="pony-ml"){
	$database->setQuery("select id from #__menu where link like '%com_ponygallery%'");
	$Itemid=$database->loadResult();
	if ($Itemid == '' || $Itemid == NULL)
		$Itemid = "";
	else
		$Itemid = "&amp;Itemid=$Itemid";
    }
    else
    	$Itemid = joom_getItemid();

    // See if we're showing backend-uploaded images:
    $hide_backend = ($params->get('hidebackend'))?"\n AND a.useruploaded = '1'":"";

    $return="";  //String to return for output
    if($tab->description != null) 
        $return .= "\t\t<div class=\"tab_Description\">".unHtmlspecialchars(getLangDefinition($tab->description))."</div>\n";
		
    // Determine # of pics for pagination	
    $username = $database->getEscaped($user->username);
    $database->setQuery("SELECT count(id) FROM $db_name as a " 
                . "\n  WHERE a.published = '1'"
				. "\n AND a.owner = '$username'"
				. $hide_backend
				. "\n AND a.approved = 1");

    $total=$database->loadResult();
    
    // Hide tab if no pics and it is configured to hide:
    if (($total==0) && ($params->get('showEmptyTab','0')==0))
    	return null;
    	
    // Pagination:
    $startpage=1;
    $picsperpage = $params->get('picsperpage','');
    if (!$picsperpage)
    	$picsNumber = ($gallery_version=="joom")?$jg_perpage:$ag_perpage;
    else 
    	$picsNumber = $picsperpage;
    	
    $pagingParams = $this->_getPaging(array(),array("gallerytab_"));
    if ($pagingParams["gallerytab_limitstart"] === null) 
    	$pagingParams["gallerytab_limitstart"] = "0";
    if ($picsNumber > $total) 
    	$pagingParams["gallerytab_limitstart"] = "0";
	    
	   
    // Include Header (Information) on first page:
    $showUploadLink = (($params->get('uploadLinkEnabled', '1')==1) && ($user->id == $my->id));
    if ($pagingParams["gallerytab_limitstart"] == "0")
		$return .= $this->getHeader($showUploadLink, $total, $Itemid, $gallery_version);
	
	// Start of pics table:	
    $return.= "<table  class='sectiontableentry2' width='100%' border='0' cellspacing='1' cellpadding='4'>";
    
    // Order images by:
    $sortby=$database->getEscaped($params->get('sortBy','catid ASC'));
    if ($sortby =="rating"){
    	$database->setQuery(
        "SELECT *, ROUND(a.imgvotesum/a.imgvotes, 2) as rating FROM $db_name as a" 
            . "\n  WHERE a.published = '1' " . " AND a.approved = 1"
            . "\n AND a.owner = '$user->username'"
            . $hide_backend
            . "\n ORDER BY rating DESC" 
			. "\n LIMIT ".($pagingParams["gallerytab_limitstart"]?$pagingParams["gallerytab_limitstart"]:"0").",".$picsNumber);
    } 
    else {
    	$sortby = "a.".$sortby;
	    // Main query:   
    	$database->setQuery(
        	"SELECT * FROM $db_name as a " 
            . "\n  WHERE a.published = '1' AND a.approved = 1"
            . "\n AND a.owner = '$username'"
            . $hide_backend 
            . "\n ORDER BY ".$sortby
			. "\n LIMIT ".($pagingParams["gallerytab_limitstart"]?$pagingParams["gallerytab_limitstart"]:"0").",".$picsNumber);
    }

    $rows=$database->loadObjectList();
    $return.= "<tr>";
    $rowcounter=0;
    
    
    foreach ( $rows as $row1 ){
    	if ( ($rowcounter % 3 == 0) AND ($rowcounter <> 0) )
        	$return.="</tr><tr>";
        
        if ($gallery_version == "joom") // let JoomGallery handle the kind of link to display:
    		$link = joom_openimage($jg_detailpic_open, $row1->id, $row1->imgfilename, $row1->imgtitle,$row1->imgtext);
    	else if ($gallery_version == "pony-ml")
    		$link = openimage($ag_detailpic_open, $row1->id, $row1->imgfilename, $row1->imgtitle,$row1->imgtext);
    	else	// Fallback for Ponygallery, shows detailed view:
    		$link = sefRelToAbs("index.php?option=com_ponygallery".$Itemid."&amp;func=detail&amp;id=".$row1->id);
    
        $return.= "<td class='sectiontableentry1' width='34%' align='center' valign='bottom'>";
		$return.= "<a href=\"$link\">"
			."<img src='$thumbnailpath$row1->imgthumbname' border='0' title='$row1->imgtext'>"
			."</a><br />";
		$return .= "<b>$row1->imgtitle</b>";
		
        // Display Category path:
        if ($params->get('showCategory','1')==1){
			$Category = $this->ShowCategoryPath($row1->catid, $db_catg_name);
			$return .= "<br />in: $Category";
		}
		
        // Display Details and rating:
        if ($showdetail )
            $return.= "<br />".(($gallery_version =="joom")? _JOOMGALLERY_HITS: _PONYGALLERY_HITS).": $row1->imgcounter";
        if ( $showrating ){
            if ( $row1->imgvotes > 0 ){
                    $fimgvotesum=number_format( $row1->imgvotesum / $row1->imgvotes, 2, ",", "." );
                    $frating="$fimgvotesum ($row1->imgvotes Votes)";
	    }
            else {
                $frating=($gallery_version =="joom")? _JOOMGALLERY_NO_VOTES: _PONYGALLERY_NO_VOTES;
	    }

            $return.="<br />".(($gallery_version =="joom")? _JOOMGALLERY_RATING: _PONYGALLERY_RATING).": $frating";
	}
        
        // Comments:
        if ( $showcomment ){
            
            // Check how many comments exist
            $database->setQuery( "SELECT cmtid FROM $db_cmt_name WHERE cmtpic='$row1->id'" );
            $comments_result=$database->query();
            $comments=mysql_num_rows( $comments_result );
            $return.= "<br />".(($gallery_version =="joom")? _JOOMGALLERY_COMMENT: _PONYGALLERY_COMMENT) .": $comments";
        }

        $return.= "</td>";
        $rowcounter++;
	}

    	if ( $rowcounter % 3 <> 0 ){
    	for ( $i=1; $i <= (3 - ($rowcounter % 3)); $i++ ) {
			$return.= "<td class='sectiontableentry1' width='34%' valign='top'> </td>";
		}
	}

    	$return.= "</tr></table>";
    
	// Pagination, if configured to show:
	$showPagination = ($params->get('pagination','1')=='1');
	if ($showPagination &&($picsNumber < $total)) {
		$return .= "<div style='width:95%;text-align:center;'>"
		.$this->_writePaging($pagingParams,"gallerytab_",$picsNumber,$total)
		."</div>";
	}

	
	$showTag = ($params->get('showtag','1')=='1');
	if ($showTag)
		$return .="\n<div align=\"center\" class=\"small\">$tag</div>";
	
	return $return;	
    }
}
?>